## M2 Connector (P2)
M.2, formerly known as the Next Generation Form Factor (NGFF), is a specification for internally mounted computer expansion cards and associated connectors. M.2 replaces the mSATA standard, which uses the PCI Express Mini Card physical card layout and connectors.

---TBU---

### Pinout Table
Helios64 provides UEXT on header P2 which following the UEXT standard, containing UEXT, SPI, and I2C connector.
You can find the P2 header from the connector/interface list at [hardware overview](/helios64/hardware) page.

![P5 Pinout](/helios64/img/hardware/UEXT_pinout.png)

Below is the detailed description of UEXT header pinout:

| PIN | Port | Remarks |
|-----|------|-------------|
|1 |3.3V|
|2 |GND|
|3 |TXD (UART)|
|4 |RXD (UART)|
|5 |SCL (I2C)|
|6 |SDA (I2C)|
|7 |MISO (SPI)|
|8 |MOSI (SPI)|
|9 |SCK (SPI)|
|10 |SSEL (SPI)|

!!! Warning
       Please note the UEXT connector at Helios64 board doesn't provide the plastic covering, so be carefull with the header polarity!
Make sure your device is correctly oriented before connecting!

### SPI and I2C

---linked to SPI and I2C pages, TBU---

### Exception

We have connected the UART bus from the RK3399K to the serial console in the USB-C, so there is no dedicated line of UART in the UEXT connector.
The UART bus in this UEXT header is the parallel ones with the serial console.
Therefore if you connect some module which might ***require dedicated serial UART line*** to the RK3399K, this module ***will not be detected***.

!!! Notes
       Please note also, that GSM modules in UEXT format also will not work due to similar reason.
